/* adc.c
 *
 * materiały dydaktyczne
 *
 * 2017 JP
 * ver. 0.1
 */

#include "stm32f4xx_hal.h"

extern void _Error_Handler(char *, int);

ADC_HandleTypeDef hadc1;

/* Function prototypes -----------------------------------------------*/
void ADC_Init(void){
	GPIO_InitTypeDef GPIO_InitStruct;
	  ADC_ChannelConfTypeDef sConfig;
	  ADC_MultiModeTypeDef multimode;

	   __HAL_RCC_ADC1_CLK_ENABLE();
	   __HAL_RCC_GPIOA_CLK_ENABLE();

	    /**ADC1 GPIO Configuration
	    PA5     ------> ADC1_IN5
	    */
	    GPIO_InitStruct.Pin = GPIO_PIN_5;
	    GPIO_InitStruct.Mode = GPIO_MODE_ANALOG;
	    GPIO_InitStruct.Pull = GPIO_NOPULL;
	    HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

	    /**Configure the global features of the ADC (Clock, Resolution, Data Alignment and number of conversion)
	    */
	  hadc1.Instance = ADC1;
	  hadc1.Init.ClockPrescaler = ADC_CLOCK_SYNC_PCLK_DIV4;
	  hadc1.Init.Resolution = ADC_RESOLUTION_12B;
	  hadc1.Init.ScanConvMode = DISABLE;
	  hadc1.Init.ContinuousConvMode = DISABLE; //ENABLE;
	  hadc1.Init.DiscontinuousConvMode = DISABLE;
	  hadc1.Init.ExternalTrigConvEdge = ADC_EXTERNALTRIGCONVEDGE_NONE;
	  hadc1.Init.ExternalTrigConv = ADC_SOFTWARE_START;
	  hadc1.Init.DataAlign = ADC_DATAALIGN_RIGHT;
	  hadc1.Init.NbrOfConversion = 1;
	  hadc1.Init.DMAContinuousRequests = DISABLE;
	  hadc1.Init.EOCSelection = ADC_EOC_SINGLE_CONV;
	  if (HAL_ADC_Init(&hadc1) != HAL_OK)
	  {
	    _Error_Handler(__FILE__, __LINE__);
	  }

	    /**Configure for the selected ADC regular channel its corresponding rank in
	     * the sequencer and its sample time.
	    */
	  sConfig.Channel = ADC_CHANNEL_5; //ADC_CHANNEL_TEMPSENSOR;
	  sConfig.Rank = 1;
	  sConfig.SamplingTime = ADC_SAMPLETIME_28CYCLES;
	  if (HAL_ADC_ConfigChannel(&hadc1, &sConfig) != HAL_OK)
	  {
	    _Error_Handler(__FILE__, __LINE__);
	  }
	    /**Configure the ADC multi-mode
	    */
	  multimode.Mode = ADC_MODE_INDEPENDENT;
	  if (HAL_ADCEx_MultiModeConfigChannel(&hadc1, &multimode) != HAL_OK)
	  {
	    _Error_Handler(__FILE__, __LINE__);
	  }

}

int16_t ADC_Get(){
	   if(HAL_ADC_PollForConversion(&hadc1,100) != HAL_OK){
	     	 _Error_Handler(__FILE__, __LINE__);
	    }
	    uint32_t val = HAL_ADC_GetValue(&hadc1);
	    return val;
}
